<template>
  <v-container class="grey lighten-4" fluid>
    <v-row>
      <v-spacer></v-spacer>
      <v-col v-for="datas in dataObj" :key="datas.id" cols="12" sm="6" md="4">
        <v-card>
          <v-img
            height="300px"
            @click="openImage(datas.doc)"
            :src="datas.doc"
            v-if="datas.doc != '-'"
            style="cursor:pointer"
          >
            <v-chip class="ma-1" color="indigo darken-3" outlined>
              <v-icon left> mdi-calendar-range </v-icon>
              <span
                class="d-inline-block"
                v-text="new Date(datas.date).toISOString().substr(0, 10)"
              ></span>
            </v-chip>
          </v-img>
          <v-img
            src="https://firebasestorage.googleapis.com/v0/b/iexpenses-project.appspot.com/o/mainBucket%2Fbill%2FlllMw84gF4QU8gaqcIlSomE9OCp2%2Fnothing?alt=media&token=cfee1b98-f8b9-4b75-8b63-61b39ccd12fc"
            height="300px"
            v-if="datas.doc == '-'"
          >
            <v-chip class="ma-1" color="indigo darken-3" outlined>
              <v-icon left> mdi-calendar-range </v-icon>
              <span
                class="d-inline-block"
                v-text="new Date(datas.date).toISOString().substr(0, 10)"
              ></span>
            </v-chip>
          </v-img>

          <v-card-actions class="justify-center">
            <v-chip class="ma-1" color="success" outlined>
              <v-icon left> mdi-storefront </v-icon>
              <span class="d-inline-block" v-text="`ร้าน ${datas.name}`"></span>
            </v-chip>

            <v-chip class="ma-1" color="orange" outlined>
              <v-icon left> mdi-currency-usd </v-icon>
              <span
                class="d-inline-block"
                v-text="
                  `ใช้จ่ายไป ${parseInt(datas.price).toLocaleString('th-TH', {
                    style: 'currency',
                    currency: 'THB',
                  })}`
                "
              ></span>
            </v-chip>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
  </v-container>
</template>
<script>
import covertDate from '@/mixins/formateDate'
import { mapGetters, mapActions, mapState } from 'vuex'

export default {
  mixins: [covertDate],
  data: () => ({
    types: ['Places to Be', 'Places to See'],
    dataObj: [],
    socials: [
      {
        icon: 'mdi-google-maps',
        color: 'indigo darken-4',
      },
      {
        icon: 'mdi-link-variant',
        color: 'green accent-4',
      },
      {
        icon: 'mdi-pencil',
        color: 'orange darken-2',
      },
      {
        icon: 'mdi-delete',
        color: 'red darken-2',
      },
    ],
  }),
  watch: {
    getExpensesTable() {
      this.testFunction(this.$nuxt.$store.state.expensestable.ExpensesTable)
    },
  },
  computed: {
    ...mapState({
      getExpensesTable: (state) => state.expensestable.ExpensesTable,
    }),
  },
  mounted() {
    this.callTableAll()
  },

  methods: {
    ...mapActions({
      callTableAll: 'callTableAll',
    }),
    testFunction(exTable) {
      const minVal = exTable.reduce((prev, cur) =>
        cur.date < prev.date ? cur : prev
      )
      const lastDate = new Date(minVal.date).getTime()
      const getLastDate = new Date(
        new Date().toISOString().substr(0, 10)
      ).getTime()

      const dataRes = this.totalTypeMulti(exTable, lastDate, getLastDate)
      this.dataObj = dataRes.sort((a, b) =>
        a.date > b.date ? -1 : a.date < b.date ? 1 : 0
      )
    },
    totalTypeMulti(dataRes, dataStart, dateEnd) {
      const dateFunction = this.filterdate(dataRes, dataStart, dateEnd)

      // จัดกรุ๊ปใหม่
      let newObj = []
      dateFunction.forEach((data) => {
        newObj = [
          ...newObj,
          {
            id: data.id,
            no: data.no,
            doc: data.doc,
            name: data.storesExpenses.name,
            date: new Date(data.date).getTime(),
            price: data.price,
          },
        ]
      })
      // คำนวนผลรวมแยกตาม วันที่ และ ไอดี ประเภทค่าใช้จ่าย
      var helper = {}
      var resultVal = newObj.reduce(function (prev, cur) {
        var key = cur.date + '-' + cur.no

        if (!helper[key]) {
          helper[key] = Object.assign({}, cur) // create a copy of o
          prev.push(helper[key])
        } else {
          helper[key].price += cur.price
        }
        return prev
      }, [])
      return resultVal
    },
    filterdate(dataRes, dataStart, dateEnd) {
      let firstDate = parseInt(dataStart)
      let lastDate = parseInt(dateEnd) + 86390000
      const dateFind = dataRes.filter((dataval) => {
        return (
          new Date(dataval.date).getTime() >= firstDate &&
          new Date(dataval.date).getTime() <= lastDate
        )
      })

      return dateFind
    },
    getImage() {
      const min = 550
      const max = 560

      return Math.floor(Math.random() * (max - min + 1)) + min
    },
    openImage(url) {
      var win = window.open(url, '_blank')
      win.focus()
    },
  },
}
</script>
